/***************************************************************************
 *   Copyright (C) 2005 by David Voswinkel                                 *
 *   d.voswinkel@netcologne.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "kbtsco.h"
#include "trayicon.h"
#include "kbtscoworker.h"

#include <kcmdlineargs.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <kconfig.h>
#include <kdebug.h>

#include "qtimer.h"

extern int catched_signal;

KBtsco::KBtsco() :
        KUniqueApplication(0, "kbtsco")
{
    m_config = new KConfig("kbtscorc");
    m_config->setGroup("General");
    m_config->writeEntry("AutoStart", true);
    m_config->sync();
    m_trayIcon = new TrayIcon(this);
    setMainWidget(m_trayIcon);
    kdDebug (200011) << "KBtsco::KBtsco  this=" << this << endl;
    QTimer::singleShot(500, this, SLOT(checkShutdown()));
}

KBtsco::~KBtsco()
{
    delete m_config;
    delete m_trayIcon;
    kdDebug (200011) << "KBtsco::~KBtsco" << endl;
}

int KBtsco::newInstance()
{
    // KBtsco is started via autostart. If session management
    // is activated it will be called twice after login. This would
    // set the tray icon to visible every time, so we turn off
    // session management.
    disableSessionManagement();

    //KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
    bFirstNewInstance = false;
    return 0;
}

void KBtsco::configUpdate()
{

}
void KBtsco::checkShutdown()
{
    if (!catched_signal){
        QTimer::singleShot(500, this, SLOT(checkShutdown()));
    } else {
        kdDebug (200011) << "KBtsco::checkShutdown pending signal=" << catched_signal << ", try clean shutdown" << endl;
        emit(quit());
    }
}

#include "kbtsco.moc"
