/***************************************************************************
 *   Copyright (C) 2005 by David Voswinkel                                 *
 *   d.voswinkel@netcologne.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "kbtsco.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

#include <iostream>
#include <signal.h>

int catched_signal = 0;

static const char description[] =
    I18N_NOOP("KDE Bluetooth-Alsa - This project provides a way to use a bluetooth headset with Linux");

static const char version[] = "0.1";

static KCmdLineOptions options[] =
{
    KCmdLineLastOption
};


void sig_term(int signum)
{
    catched_signal = signum;
}

int main(int argc, char **argv)
{
    KAboutData about("KBtsco", I18N_NOOP("KBtsco"), version, description,
                     KAboutData::License_GPL, "(C) 2005 David Voswinkel", 0, 0, "d.voswinkel@netcologne.de");
    about.addAuthor( "David Voswinkel", 0, "d.voswinkel@netcologne.de" );
    about.addAuthor( "Thorsten Reinecke", 0, "t.reinecke@netcologne.de" );

    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KUniqueApplication::addCmdLineOptions();
    if (!KUniqueApplication::start()) {
        std::cerr << i18n("KBtsco is already running.\n").local8Bit();
        return 0;
    }

    struct sigaction sa;
    memset(&sa, 0, sizeof(sa));
    sa.sa_flags = SA_NOCLDSTOP;
    sa.sa_handler = sig_term;
    sigaction(SIGTERM, &sa, NULL);
    sigaction(SIGINT, &sa, NULL);
    sa.sa_handler = SIG_IGN;
    sigaction(SIGCHLD, &sa, NULL);
    sigaction(SIGPIPE, &sa, NULL);

    KBtsco * app = new KBtsco;
    int ret = app->exec();
    delete app;
    return ret;
}

