/***************************************************************************
 *   Copyright (C) 2005 by David Voswinkel                                 *
 *   d.voswinkel@netcologne.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef TRAYICON_H
#define TRAYICON_H

#include <ksystemtray.h>
#include <kpixmap.h>
#include <qobject.h>
#include <qvariant.h>
#include <qwidget.h>
#include <map>

class QTimer;
class KToggleAction;
class KAction;
class KActionMenu;
class KPopupMenu;
class KHelpMenu;
class KBtsco;
class KBtscoworker;
class OSDWidget;
class KBtscoWorker;
class TrayIcon : public KSystemTray
{
Q_OBJECT
public:
    TrayIcon(KBtsco * app);
    ~TrayIcon();

public slots:

private slots:
    void updateIcon();
    void slotQuitSelected();
    void slotReportBug();
    void slotAbout();
    void slotShowHelp();
    void slotHeadsetConfig();
    void slotHeadsetConnect();
    void slotHeadsetDisconnect();

protected:
    void mousePressEvent(QMouseEvent *e);
    virtual void closeEvent(QCloseEvent *e);
    virtual void enterEvent (QEvent *e );
    virtual void customEvent (QCustomEvent * e);

private:
    KBtsco  *app;
    bool hasAddress;
    bool osdEnabled;
    bool acceptClose;
    typedef enum  { STATE_NONE = 0, STATE_IDLE,STATE_CONNECTING , STATE_CONNECTED , STATE_CONNECTED_SCO} state_t;
    state_t state;
    state_t state_last;
    void setConnectionState(state_t state = STATE_NONE );
    KPixmap iconNoAddress;
    KPixmap iconIdle;
    KPixmap iconConnecting;
    KPixmap iconConnected;
    KPixmap iconConnectedsco;
    QTimer *blinkTimer;
    bool iconConnectingBlinkState;
    int  iconConnectedBlinkState;
    bool iconConnectedSCOBlinkState;
    KToggleAction* showIconAction;
    KAction *headsetConfigAction;
    KAction *showHelpAction;
    KAction *headsetConnectAction;
    KAction *headsetDisconnectAction;
    KActionMenu *configActionMenu;
    KActionMenu *helpActionMenu;
    KHelpMenu *helpMenu;
    KConfig* m_config;
    QString  m_dev_baddr;
    QString  m_dev_name;
    OSDWidget *m_osd;
    KBtscoWorker *m_worker;
};

#endif
